# Copyright (C) 2020 ASTRON (Netherlands Institute for Radio Astronomy)
# SPDX-License-Identifier: GPL-3.0-or-later

cmake_minimum_required(VERSION 3.17)

set(IDG_VERSION "1.2.0")
if(IDG_VERSION MATCHES "^([0-9]+)\\.([0-9]+)\\.([0-9]+)")
  set(IDG_VERSION_MAJOR "${CMAKE_MATCH_1}")
  set(IDG_VERSION_MINOR "${CMAKE_MATCH_2}")
  set(IDG_VERSION_PATCH "${CMAKE_MATCH_3}")
else()
  message(FATAL_ERROR "Failed to parse IDG_VERSION='${IDG_VERSION}'")
endif()

project(idg VERSION ${IDG_VERSION})

option(WRITE_OUT_SCALAR_BEAM "Write scalar beam to scalar_beam.npy" OFF)
option(BUILD_WITH_DEMOS "Build with demos" OFF)
option(BUILD_WITH_MPI "Build with MPI" OFF)
option(BUILD_PACKAGES "Build package(s)" OFF)
option(BUILD_TESTING "" OFF)

set(CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake/modules"
                      ${CMAKE_MODULE_PATH})

include(CTest)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED YES)
set(CMAKE_CXX_EXTENSIONS NO)

# Update submodules as needed
option(GIT_SUBMODULE "Update submodules during build" ON)
if(GIT_SUBMODULE)
  find_package(Git QUIET)
  if(GIT_FOUND AND EXISTS "${PROJECT_SOURCE_DIR}/.git")
    message(STATUS "Syncing submodules")
    # Account for potential changes in git repo URL's
    execute_process(
      COMMAND ${GIT_EXECUTABLE} submodule sync --recursive
      WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
      RESULT_VARIABLE GIT_SUBMOD_RESULT)
    if(NOT GIT_SUBMOD_RESULT EQUAL "0")
      message(
        FATAL_ERROR
          "Syncing submodules did not succeed"
          "command '${GIT_EXECUTABLE} submodule sync --recursive' failed with exit code ${GIT_SUBMOD_RESULT}"
      )
    endif()
    message(STATUS "Updating submodules")
    execute_process(
      COMMAND ${GIT_EXECUTABLE} submodule update --init --recursive --checkout
              --depth 1
      WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
      RESULT_VARIABLE GIT_SUBMOD_RESULT)
    if(NOT GIT_SUBMOD_RESULT EQUAL "0")
      message(
        FATAL_ERROR
          "git submodule update --init failed with ${GIT_SUBMOD_RESULT}, please checkout submodules"
      )
    endif()
  endif()
endif()

include_directories(${CMAKE_SOURCE_DIR}/external/aocommon/include/)
include(external/aocommon/CMake/FetchXTensor.cmake)

# build shared libraries
set(BUILD_SHARED_LIBS TRUE)
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

# Set rpath to install directory
set(CMAKE_INSTALL_RPATH ${CMAKE_INSTALL_PREFIX}/lib ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)

set(IDG_FOUND True)
set(IDG_INCLUDE_DIR
    ${CMAKE_SOURCE_DIR}/idg-lib/src ${CMAKE_BINARY_DIR}/idg-lib/src
    ${CMAKE_SOURCE_DIR}/idg-util/src ${CMAKE_BINARY_DIR}/idg-util/src)
set(IDG_UTIL_INCLUDE_DIR ${CMAKE_SOURCE_DIR}/idg-util/src
                         ${CMAKE_BINARY_DIR}/idg-util/src)
set(IDG_LIBRARY idg)

# Version. idg-lib puts the version info in idg-config.h.in.
include(cmake/version.cmake)
if(GIT_TAG)
  if(${IDG_VERSION} VERSION_LESS ${GIT_TAG})
    message(
      FATAL_ERROR
        "The IDG version is less than the most recent git tag ${GIT_TAG}. Please check the version and the tag."
    )
  endif()

  # For tag pipelines on CI, the version should always match the tag.
  if(DEFINED ENV{CI_COMMIT_TAG})
    if(NOT $ENV{CI_COMMIT_TAG} VERSION_EQUAL ${IDG_VERSION})
      message(
        FATAL_ERROR
          "Git tag $ENV{CI_COMMIT_TAG} does not match the IDG version ${IDG_VERSION}. Please create a matching tag for the master branch."
      )
    endif()
  endif()
endif()

# User may optionally set `TARGET_CPU` if `PORTABLE=OFF`
option(PORTABLE "Build portable binaries (with slightly decreased performance)"
       OFF)
include(external/aocommon/CMake/SetTargetCPU.cmake)

# MPI
if(BUILD_WITH_MPI)
  find_package(MPI REQUIRED)
endif()

# Python
option(BUILD_WITH_PYTHON "Build Python bindings" OFF)

if(BUILD_WITH_PYTHON)
  if(${CMAKE_VERSION} VERSION_GREATER "3.12.4")
    find_package(Python REQUIRED)
    set(PYTHON_VERSION ${Python_VERSION})
    set(PYTHON_VERSION_MAJOR ${Python_VERSION_MAJOR})
    set(PYTHON_VERSION_MINOR ${Python_VERSION_MINOR})
  else()
    find_package(PythonInterp REQUIRED)
    set(PYTHON_VERSION ${PYTHON_VERSION_STRING})
  endif()

  if(${PYTHON_VERSION} VERSION_LESS "3.6")
    message(
      FATAL_ERROR
        "IDG requires python version >= 3.6, but found ${PYTHON_VERSION}. Using cmake >= 3.12 might fix this error"
    )
  endif()
  if(BUILD_PACKAGES)
    set(PYTHON_INSTALL_DIR
        lib/python${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR}/dist-packages/idg
    )
  else()
    set(PYTHON_INSTALL_DIR
        lib/python${PYTHON_VERSION_MAJOR}.${PYTHON_VERSION_MINOR}/site-packages/idg
    )
  endif()
endif()

set(LIBDIRAC_PREFIX
    ""
    CACHE FILEPATH "Path to libdirac install root")
if(NOT "${LIBDIRAC_PREFIX}" STREQUAL "")
  #Find pkg-config and try to find libdirac (only if -DLIBDIRAC_PREFIX given)
  find_package(PkgConfig REQUIRED)
  # Set search path to install directory of libdirac
  set(ENV{PKG_CONFIG_PATH} "${LIBDIRAC_PREFIX}/lib/pkgconfig")
  pkg_search_module(LIBDIRAC libdirac>=0.8.1)
endif()
if(LIBDIRAC_FOUND)
  message(STATUS "Found libdirac: ${LIBDIRAC_INCLUDE_DIRS}")
  include_directories(${LIBDIRAC_INCLUDE_DIRS})
  add_definitions(-DHAVE_LIBDIRAC)
else()
  message(
    STATUS
      "Libdirac NOT found; LBFGS solve algorithm not available. Set LIBDIRAC_PREFIX to enable."
  )
endif()

if(BUILD_TESTING)
  find_package(
    Boost
    COMPONENTS unit_test_framework
    REQUIRED)

  # Add a test and let ctest automatically (re)build the test if needed.
  function(add_built_test TEST_NAME)
    cmake_parse_arguments(ARG "" "LABEL" "" ${ARGN})

    add_test(NAME build-${TEST_NAME}
             COMMAND ${CMAKE_COMMAND} --build ${CMAKE_BINARY_DIR} --target
                     ${TEST_NAME})
    # Running multiple build commands in parallel yields race conditions.
    set_tests_properties(build-${TEST_NAME}
                         PROPERTIES FIXTURES_SETUP ${TEST_NAME} RUN_SERIAL true)
    set(JUNIT_ARG)
    if(ARG_LABEL STREQUAL "unit")
      set(JUNIT_ARG -f JUNIT -k unittest_${TEST_NAME}.xml)
    endif()
    add_test(NAME ${TEST_NAME} COMMAND ${TEST_NAME} ${JUNIT_ARG})
    set_tests_properties(${TEST_NAME} PROPERTIES FIXTURES_REQUIRED ${TEST_NAME})
    if(ARG_LABEL)
      set_tests_properties(${TEST_NAME} PROPERTIES LABELS ${ARG_LABEL})
    endif()
    set_property(
      TEST ${TEST_NAME}
      APPEND
      PROPERTY ENVIRONMENT IDG_DATA_DIR=${CMAKE_SOURCE_DIR}/idg-util/data
               IDG_INC_DIR=${CMAKE_BINARY_DIR}/include
               IDG_LIB_DIR=${CMAKE_BINARY_DIR}/lib)
  endfunction()
endif()

add_subdirectory("idg-util")
add_subdirectory("idg-lib")
add_subdirectory("idg-bin")
add_subdirectory("idg-api")
if(BUILD_WITH_PYTHON)
  add_subdirectory("idg-cal")
endif()
add_subdirectory("doc")

# Write environment-module
configure_file("${PROJECT_SOURCE_DIR}/cmake/config/environment-module.in"
               "${PROJECT_BINARY_DIR}/idg.env")

# Install environment-module
install(FILES ${PROJECT_BINARY_DIR}/idg.env DESTINATION share)

# Add integration tests
add_subdirectory(test)

# Packaging
if(BUILD_PACKAGES)
  add_subdirectory(cpack)
endif()
